#include "xmpl.h"
FD_xmpl *fdui;

pthread_t *play_thread;


static volatile int running = 0; 
static volatile int stop = 0;    
int new_program_flag;
static char *helper_command;


void *play_routine()
{
int a;
char temp[1024];
FILE *pptr;
char *ptr, *ptr1;
int play_status;

if(debug_flag)
	{
	fprintf(stdout, "play_routine(): arg none\n");
	}

while(1)
	{
	if(new_program_flag)
		{
		if(debug_flag)
			{
			printf("start play_process\n");
			}

		new_program_flag = 0;
		repeat_count = 0;
		while(1)
			{		
			running = 1;

			/* a = 0 is not found */
			ptr = line_to_filename(selected_title);
			if(ptr)
				{
//printf("selected_title=%d ptr=%s\n", selected_title, ptr); 
				if(selected_file) free(selected_file);
				selected_file = strsave(ptr);   
				}
			else /* end of list */
				{
				if(repeat_mode == PLAY_REPEAT_SELECTION)
					{
					/* start again from beginning of list */

					selected_title = 1;
					continue;
					}
				else if(repeat_mode == PLAY_REPEAT_NONE) 
					{
					/* end of list */
					break;
					}
				} /* end if end of list */

			a = get_play_status(selected_title, &play_status, &play_volume);
			if( (a) && ( (play_status & NO_PLAY) == 0) )
				{
				new_title_flag = 1;

				if(selected_file)
					{
					/* filter for true .xxx or .XXX extentions */
					ptr = strrchr(selected_file, '.');

					/* .anything */
					if(ptr)
						{
						/*
						find a suitable helper program for this extention
						*/
						if(helper_command) free(helper_command);
						helper_command = get_helper_command(ptr + 1);
						if(! helper_command)
							{
							stop = 1; /* ?? and / or error message ? */
//							break;
							}

						strcpy(playing_title, selected_file);

						new_volume_flag = 1;

						playing_flag = 1;
						pptr = popen(helper_command, "w");
						pclose(pptr);

						playing_flag = 0;

						audio_device_busy_flag = 0;
						} /* end if ptr (extention specified) */
					} /* end if selected_file */
				} /* end if not end of list and no play  */

			if(stop)
				{
				break;
				}

			if(selected_repeats)
				{
				if(repeat_count < selected_repeats)
					{
					repeat_count++;
					continue;
					}

				} /* end if selected_repeats */

			if(repeat_mode == PLAY_REPEAT_NONE) break;
			if(repeat_mode == PLAY_REPEAT_CURRENT) continue;
			if(repeat_mode == PLAY_REPEAT_SELECTION) selected_title++;
			} /* end while ! stop */
		running = 0;
		
		if(debug_flag)
			{
			printf("exit play_process()\n");
			}

		} /* end if new_program_flag */
	/* take it easy on processor cycles */
	usleep(10000);
	} /* end if program has changed */

return;
} /* end function play_routine */


int play_init()
{
if(debug_flag)
	{
	printf("play_init(): arg none\n");
	}

pthread_create(\
(pthread_t *)&play_thread, NULL , &play_routine, NULL);

return 1;
} /* end function play_init */


void play_start()
{
char temp[1024];

if(debug_flag)
	{
	printf("play_start() arg none\n");
	}

new_program_flag = 1;

audio_device_busy_flag = 0;
} /* end function play_start */


void play_stop()
{
if(debug_flag)
	{
	printf("play_stop(): arg none\n");
	}

stop = 1;

stop_players();

if(running)
	{
	stop = 1;
	while(running)
		{
		fl_set_object_label(fdui -> main_form_status_display,\
		"Waiting for play thread to stop");
		usleep(100000);
		}
	} /* end if running */

stop = 0;

} /* end function play_stop */


int stop_players()
{
int a, i;
int pid;
char temp[4096];
#ifndef USE_PS
char temp2[4096];
#endif
FILE *pptr;
FILE *fptr;
int pids[4];

if(debug_flag)
	{
	printf("stop_players(): arg none using playing_title=%s\n",
	playing_title);
	}

if(strlen(playing_title) == 0)
	{
	return 0;
	}

#ifdef USE_PS
 /* test for running process for this filename */
 sprintf(temp, "ps x | grep %s > %s/.xmpl/processlist.txt",\
 playing_title, home_dir);
#else
 sprintf(temp, "fuser %s > %s/.xmpl/processlist.txt",\
 selected_audio_device_name, home_dir);
#endif

if(debug_flag)
	{
	printf("stop_players(): executing temp=%s\n", temp);
	}
	
pptr = popen(temp, "r");
pclose(pptr);

/* read the created process list */
sprintf(temp, "%s/.xmpl/processlist.txt", home_dir);
fptr = fopen(temp, "r");
if(! fptr)
	{
	fl_show_alert("Could not open file for read", temp, "", 0);

	return 0;
	}

while(1)
	{
	temp[0] = 0;
	/* closes file if EOF */
	a = readline(fptr, temp);
	if(a == EOF) break;

	if(debug_flag)
		{
		printf("read temp=%s\n", temp);
		}

	if(strlen(temp) == 0) break;

#ifdef USE_PS /* use ps -x */
	/*
	14189 ttyp2    S      0:00 mpg123 -a /dev/dsp1 /root/mp1/Life_A_Celebration/Jaag_Piyari_Ab_Ka.mp3
	14235 ttyp3    S      0:00 grep /root/mp1/Life_A_Celebration/Jaag_Piyari_Ab_Ka.mp3
	*/
	
	a = sscanf(temp, "%d", &pid);
	if(a == 1)
		{
		sprintf(temp, "kill -s KILL %d 1> /dev/null 2> /dev/null", pid);
		
		if(debug_flag)
			{
			printf("executing temp=%s\n", temp);
			}

		pptr = popen(temp, "w");
		pclose(pptr);
		}	
#else /* use fuser */
	/*
	/dev/dsp:             2166
	*/
	a = sscanf(temp, "%s %d %d %d %d",\
	temp2, &pids[0], &pids[1], &pids[2], &pids[3]);

	for(i = 0; i < a - 1; i++)
		{
		sprintf(temp,\
		"kill -s KILL %d 1> /dev/null 2> /dev/null",\
		pids[i]);
		
		if(debug_flag)
			{
			printf("executing temp=%s\n", temp);
			}

		pptr = popen(temp, "w");
		pclose(pptr);
		} /* end while all pids in a line from fuser */
#endif /* use fuser */

	} /* end while all lines in file */

return 1;
} /* end function stop_playing */

