/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
~*/


#include "xmpl.h"

extern FD_xmpl *fdui;
extern FD_xmpl *fd_main_form;

FL_APPEVENT_CB optimize_idle_cb;


int idle_cb(XEvent *ev, void *data)
{
int a;
unsigned long la;
char temp[512];
FILE *pptr;
int status;
int seconds;
unsigned long lthousands;
int hour;
int minute;
int second;
int tenth;
static unsigned long counter;
unsigned long lstart_usecs, lcurrent_usecs, ldiff_usecs;
char *ptr;
char volume_str[80];

if(! allow_idle_cb) return 1;

/*
This will kill any zombies left.
*/
waitpid (WAIT_ANY, &status, WNOHANG);

//if(counter <= 0)
	{
	/* calcule hour, minute, second, tenth */
//	lthousands = current_frame * dmilli_seconds_per_frame;

	hour = lthousands / 3600000;
	lthousands -= hour * 3600000; 

	minute = lthousands / 60000;
	lthousands -= minute * 60000;
	
	second = lthousands / 1000;
	lthousands -= second * 1000;

	tenth = lthousands / 100;

	if(audio_device_busy_flag)
		{
		sprintf(temp,\
	"Found audio device BUSY, wait, or try STOP button, and / or other audio device.");

		} /* end if audio device busy */
	else
		{
		if(playing_flag)
			{
			if(play_volume)
				{
				sprintf(volume_str, "vol=%d (%d)",\
				play_volume, selected_volume);
				}
			else
				{
				volume_str[0] = 0;
				}

			if(selected_repeats)
				{
				sprintf(temp, "list:%s  file:%s  (%d/%d)  %s",\
				selected_play_list_file_name, selected_file,\
				repeat_count + 1, selected_repeats + 1,\
				volume_str);
				}
			else
				{
				sprintf(temp, "list:%s  file:%s  %s",\
				selected_play_list_file_name, selected_file,\
				volume_str);
				}
			}
		else
			{
			sprintf(temp, "");
			}
		} /* end if audio device not busy */

	fl_set_object_label(fdui -> main_form_status_display, temp);

	if(new_title_flag)
		{
		/* selected_title is set by the audio thread */

		fl_select_browser_line(\
		fdui -> main_form_title_list_browser, selected_title);

		fl_set_browser_topline(\
		fdui -> main_form_title_list_browser, selected_title - 10);

		/* save position */
		save_general_settings();

		set_selected_entry_in_play_list(selected_title);
		save_play_lists();
				
		set_title();

		new_title_flag = 0;
		}

	test_alarm();

	if(new_volume_flag)
		{
		if(play_volume)
			{
			set_mixer_volume(play_volume);

//			sprintf(temp, "%d", selected_volume);
//			fl_set_object_label(fdui -> main_form_volume_slider, temp);
			}
		else
			{
			set_mixer_volume(selected_volume);
//			fl_set_object_label(fdui -> main_form_volume_slider, "volume");
			}

		new_volume_flag = 0;
		}

	/* reload counter */
	counter = 10;
	} /* end if counter == 0 */
	
/* decrement counter */
counter --;

return 1;
}/* end function idle_cb */

