/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xmpl.h"

FD_xmpl *fdui;


FD_xmpl *create_form_main_form(void)
{
FL_OBJECT *obj;

extern int idle_cb();

fdui = (FD_xmpl *) fl_calloc(1, sizeof(*fdui));

fl_set_idle_callback(idle_cb, 0);

fdui -> helpers_form =\
fl_bgn_form(FL_UP_BOX, 400, 330);

fdui -> helpers_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 150, 5, 100, 30,\
	"H E L P E R S");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> helpers_form_input = obj =\
    /* only used as output */
	fl_add_input(FL_MULTILINE_INPUT, 10, 35, 380, 245, "");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, helpers_form_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

fdui -> helpers_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 290, 90, 30, "CANCEL");
	fl_set_object_callback(obj, helpers_form_cancel_button_cb, 0);

fdui -> helpers_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 300, 290, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, helpers_form_accept_button_cb, 0);

fdui -> helpers_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 230, 290, 20, 20, "-");
	fl_set_object_callback(obj, helpers_form_fontsize_down_button_cb, 0);

fdui -> helpers_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 260, 290, 20, 20, "+");
	fl_set_object_callback(obj, helpers_form_fontsize_up_button_cb, 0);

fl_end_form(); /* helpers_form */

fdui -> main_form =\
	fl_bgn_form(FL_NO_BOX, 610, 480);
	obj = fl_add_box(FL_UP_BOX, 0, 0, 790, 570,"");
	fl_set_object_lsize(obj,FL_HUGE_SIZE);
	fl_set_object_lstyle(obj,FL_FIXEDBOLDITALIC_STYLE + FL_EMBOSSED_STYLE);

fdui -> main_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 410, 5, 200, 30,\
	"P A N T E L T J E (c)");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);

fdui -> main_form_play_list_browser = obj =\
	fl_add_browser(FL_MULTI_BROWSER, 10, 120, 590, 320, "");
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_show_object(obj);
	fl_set_object_callback(obj, main_form_play_list_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj,\
		 main_form_play_list_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);

fdui -> main_form_title_list_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 10, 120, 590, 320, "");
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_set_object_callback(obj, main_form_title_list_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj,\
		main_form_title_list_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);
	fl_set_browser_fontsize(obj, FL_MEDIUM_SIZE); 
	fl_hide_object(obj);	

fdui -> main_form_play_list_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 40, 90, 30, "LISTS");
	fl_set_object_callback(obj, main_form_play_list_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_title_list_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 110, 40, 90, 30, "TITLES");
	fl_set_object_callback(obj, main_form_title_list_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_repeat_mode_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 210, 40, 90, 30, "");
	fl_set_object_callback(obj, main_form_repeat_mode_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> main_form_exit_switch =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 310, 40, 90, 30, "EXIT");
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_callback(obj, main_form_exit_switch_cb, 0);

fdui -> main_form_device_select_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 410, 40, 90, 30, "");
	fl_set_object_callback(obj, main_form_device_select_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> main_form_search_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 110, 80, 190, 30, "Search keywords");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_search_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> main_form_search_case_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 310, 80, 90, 30, "CASE SENS");
	fl_set_object_callback(obj, main_form_search_case_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_search_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 410, 80, 90, 30, "SEARCH");
	fl_set_object_callback(obj, main_form_search_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_volume_slider = obj =\
	fl_add_valslider(FL_HOR_BROWSER_SLIDER, 510, 80, 90, 30, "VOLUME");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_callback(obj, main_form_volume_slider_cb, 0);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
	fl_set_slider_bounds(obj, 0.0, 100.0);
	fl_set_slider_precision(obj, 0);

fdui -> main_form_stop_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 510, 40, 90, 30, "STOP");
	fl_set_object_callback(obj, main_form_stop_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> main_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 580, 450, 20, 20, "+");
	fl_set_object_callback(obj, main_form_fontsize_up_button_cb, 0);

fdui -> main_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 550, 450, 20, 20, "-");
	fl_set_object_callback(obj, main_form_fontsize_down_button_cb, 0);

fdui -> main_form_status_display =\
	obj = fl_add_text(FL_NORMAL_TEXT, 10, 450, 530, 20, "");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_YELLOW, FL_COL1);
           
fdui -> main_form_file_menu = obj =\
	fl_add_menu(FL_PULLDOWN_MENU, 10, 10, 90, 20, "FILE");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_callback(obj, main_form_file_menu_cb, 0);
	fl_set_menu(obj,\
"AUTO PLAY ON START|\
HELPERS|\
EXIT");

fdui -> main_form_play_list_menu = obj =\
	fl_add_menu(FL_PULLDOWN_MENU, 110, 10, 90, 20, "LISTS");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_callback(obj, main_form_play_list_menu_cb, 0);
	fl_set_menu(obj,\
"ADD PLAY LIST|\
RENAME PLAY LIST|\
DELETE PLAY LIST\
");

fdui -> main_form_title_list_menu = obj =\
	fl_add_menu(FL_PULLDOWN_MENU, 210, 10, 90, 20, "TITLES");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_callback(obj, main_form_title_list_menu_cb, 0);
	fl_set_menu(obj,\
"SINGLE PLAY|\
REPEAT CURRENT|\
REPEAT SELECTION|\
ADD TITLE|\
DELETE TITLE|\
GET SYSTEM MP3s|\
GET SYSTEM WAVs|\
GET SYSTEM AVIs|\
GET SYSTEM USER SPECIFIED EXTENTIONS|\
SET START FRAME|\
SET LENGTH|\
SET REPEATS|\
SET VOLUME|\
ALLOW DOUBLE ENTRIES\
");

fdui -> main_form_alarm_menu = obj =\
	fl_add_menu(FL_PULLDOWN_MENU, 310, 10, 90, 20, "ALARM");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_callback(obj, main_form_alarm_menu_cb, 0);
	fl_set_menu(obj,\
"SET ALARM TIME|\
SLEEP|\
ALARM|\
POWER DOWN PC ON SLEEP\
");

fl_end_form(); /* main form */

return fdui;
}/* end function FD_xmpl *create_form_main_form */

