/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef FD_xmpl_h_
#define FD_xmpl_h_

#include <forms.h>

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#include <math.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <errno.h>
#include <fcntl.h>
//#include <linux/soundcard.h>
#include <setjmp.h>

#include <pthread.h>
#include <sys/poll.h>

#include "play_list.h"
#include "title_list.h"
#include "xmpl_proto.h"

typedef struct {
	FL_FORM *main_form;
	FL_FORM *helpers_form;

	FL_OBJECT *main_form_window_menu;
	FL_OBJECT *main_form_status_display;
	FL_OBJECT *main_form_title;
	FL_OBJECT *main_form_file_menu;
	FL_OBJECT *main_form_play_list_menu;
	FL_OBJECT *main_form_title_list_menu;
	FL_OBJECT *main_form_alarm_menu;
	FL_OBJECT *main_form_play_list_button;
	FL_OBJECT *main_form_title_list_button;
	FL_OBJECT *main_form_play_list_browser;
	FL_OBJECT *main_form_title_list_browser;
	FL_OBJECT *main_form_device_select_button;
	FL_OBJECT *main_form_repeat_mode_button;
	FL_OBJECT *main_form_search_input_field;
	FL_OBJECT *main_form_audio_mode_button;
	FL_OBJECT *main_form_search_case_button;
	FL_OBJECT *main_form_get_all_button;
	FL_OBJECT *main_form_search_button;
	FL_OBJECT *main_form_volume_slider;
	FL_OBJECT *main_form_stop_button;
	FL_OBJECT *main_form_fontsize_up_button;
	FL_OBJECT *main_form_fontsize_down_button;
	FL_OBJECT *main_form_exit_switch;
	
	FL_OBJECT *helpers_form_title;
	FL_OBJECT *helpers_form_input;
	FL_OBJECT *helpers_form_fontsize_up_button;
	FL_OBJECT *helpers_form_fontsize_down_button;
	FL_OBJECT *helpers_form_cancel_button;
	FL_OBJECT *helpers_form_accept_button;

} FD_xmpl;

extern FD_xmpl *create_form_main_form(void);
extern FD_xmpl *create_form_helpers_form(void);

#define READSIZE	65535
#define TEMP_SIZE	65535

/* for position browser display */
#define SHOW_TOP			0
#define SHOW_SAME_POSITION	1
#define SHOW_UNREAD_AT_TOP	2
#define SHOW_BOTTOM			3

/* for status in title browser USE 1 2 4 8 */
#define NEW_ENTRY			0
#define NO_PLAY				1
	
/* for main form file menu */
#define AUTO_PLAY_ON_START	1
#define HELPERS				2
#define EXIT				3

/* for repeat modes */
#define PLAY_REPEAT_NONE		0
#define PLAY_REPEAT_CURRENT		1
#define PLAY_REPEAT_SELECTION	2

/* for audio devices */
#define AUDIO_DEVICE_1		0
#define AUDIO_DEVICE_2		1

/* for play lists */
#define ADD_PLAY_LIST		1
#define RENAME_PLAY_LIST	2
#define DELETE_PLAY_LIST	3

/* for title lists */
#define SINGLE_PLAY									1
#define REPEAT_CURRENT								2
#define REPEAT_SELECTION							3
#define ADD_TITLE									4
#define DELETE_TITLE								5
#define GET_SYSTEM_MP3s								6
#define GET_SYSTEM_WAVs								7
#define GET_SYSTEM_AVIs								8
#define GET_SYSTEM_USER_SPECIFIED_EXTENTIONS		9
#define SET_START_FRAME								10
#define SET_LENGTH									11
#define SET_REPEATS									12
#define SET_VOLUME									13
#define ALLOW_DOUBLE_ENTRIES						14

/* for browsers */
#define PLAY_LIST_BROWSER	0
#define TITLE_LIST_BROWSER	1

/* for alarm menu */
#define SET_ALARM_TIME			1
#define SLEEP					2
#define ALARM					3
#define POWER_DOWN_PC_ON_SLEEP	4

int debug_flag;
char *home_dir;
char *user_name;

int fontsizes_modified_flag;
int main_form_modified_flag;
int main_form_fontsize;
int helpers_form_fontsize;
int tab_size;
char *selected_playlist;
int selected_volume;
struct timeval *start_timeval;
struct timeval *current_timeval;
int title_list_browser_clicked_title;
int allow_idle_cb;
int repeat_mode;
char *sound_dir;
int playing_flag;
int selected_audio_device;
char *selected_audio_device_name;
char *selected_video_device_name;
char *database_file_name;
int selected_play_list;
char *selected_play_list_file_name;
int selected_title;
char *selected_file;
int visible_browser;
int new_title_flag;
int auto_play_flag;
int alarm_mode;
int alarm_hour, alarm_minute;
int sleep_mode;
int time_match_flag;
char weekday[20];
char month[20];
int monthday, hour, minute, second, year;
char playing_title[4096];
int audio_device_busy_flag;
char selected_start_frame_str[80];
char selected_length_str[80];
int selected_repeats;
int repeat_count;
int new_volume_flag;
int play_volume;
int allow_double_title_entries;
int report_flag;
int power_down_flag;

#define DATABASE_FILE_NAME	"xmpl.dat"

#define AUDIO_DEVICE1	"/dev/dsp"
#define AUDIO_DEVICE2	"/dev/dsp1"
	
#define ALARM_VOLUME	60

/*
define this if you want xmpl to use px s filename
and not fuser device to get the pid to stop a playing process
(see audio_video.c) .
*/
//#define USE_PS

#define POWER_OFF_COMMAND	"shutdown -h now &"

#define VERSION "xmpl-0.8"

#endif /* FD_xmpl_h_ */

