/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xmpl.h"

FD_xmpl *fdui;


int main(int argc, char *argv[])
{
int a, i;
int n;
char temp[1024];
struct passwd *userinfo;
char *ptr;
int selected;
FILE *fptr;
int file;
FL_IOPT fl_iopt;
    
/* some defaults */
debug_flag = 0;
database_file_name = strsave(DATABASE_FILE_NAME);
if(! database_file_name)
	{
	printf(\
	"xmpl(): main(): strsave() database_file_name failed, aborting\n");

	exit(1);
	}

alarm_mode = 0;
sleep_mode = 0;
/* end defaults */

if(argc > 1) debug_flag = 1;

/* against flashing */
/* set double buffering */
fl_iopt.doubleBuffer = 1;
fl_set_defaults(FL_PDDouble, &fl_iopt);
                   
/* get user info */
userinfo = getpwuid(getuid() );

/* get home directory */ 
home_dir = strsave(userinfo -> pw_dir);
if(! home_dir)
	{
	fprintf(stdout,\
	"main(): could allocte space for home_dir\n");
	exit(1);
	}

user_name = strsave(userinfo -> pw_name);
if(! user_name)
	{
	fprintf(stdout,\
	"main(): could allocate space for user_name\n");
	exit(1);
	}

selected_audio_device = AUDIO_DEVICE_1;

/* set default volume for sound playback */
selected_volume = 50;

fl_initialize(&argc, argv, 0, 0, 0);
fdui = create_form_main_form();

/* set default fontsizes for forms */
main_form_fontsize = 3;
load_fontsizes();

/* set default settings */
visible_browser = PLAY_LIST_BROWSER;
load_general_settings();

file = open(selected_audio_device_name,  O_RDWR | O_NONBLOCK);
if(file == -1)
	{
	audio_device_busy_flag = 1;
	}
else
	{
	close(file);
	audio_device_busy_flag = 0;
	}

load_play_lists();
sort_play_lists();
if(! show_play_lists() ) exit(1);
fl_select_browser_line(fdui -> main_form_play_list_browser,\
selected_play_list);
fl_set_browser_topline(fdui -> main_form_play_list_browser,\
selected_play_list - 10);

if(visible_browser == PLAY_LIST_BROWSER)
	{
	select_play_list();
	}
else if(visible_browser == TITLE_LIST_BROWSER)
	{
	ptr = line_to_play_list_name(selected_play_list);
	if(ptr)
		{
		if(selected_play_list_file_name) free(selected_play_list_file_name);
		selected_play_list_file_name = strsave(ptr);
		if(! selected_play_list_file_name) return;
		}

	load_titles();

	/* show browser */
	select_title_list();

	/*
	If we stopped while still playing then possibly a restart will
	happen in the same title, stop the player!
	*/
	/* get the selected entry from the play_list */
	if(get_selected_entry(selected_play_list, &selected) )
		{
		ptr = line_to_filename(selected);
		if(ptr) strcpy(playing_title, ptr);
		}

	} /* end if title list */

/* fill-in form initialization code */

/* show the main form */
fl_show_form(fdui -> main_form, FL_PLACE_FREE, FL_FULLBORDER, VERSION);

/* set the title of the main form */
selected_file = strsave("");
if(! selected_file) exit(1);
set_title();

start_timeval = malloc(sizeof(struct timeval) );
if(! start_timeval)
	{
	fprintf(stdout, "could not allocate space for start_timeval\n");

	exit(1);
	}

current_timeval = malloc(sizeof(struct timeval) );
if(! current_timeval)
	{
	fprintf(stdout, "could not allocate space for current_timeval\n");

	exit(1);
	}

/* will not work without helpers specified */
if(! load_helpers() )
	{
	sleep(1);
	exit(1);
	}

play_init();

allow_idle_cb = 1;

if(auto_play_flag)
	{
	play_stop();

	play_start();	
	}

fl_do_forms();

return 0;
} /* end function main */

