
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xmpl.h"

extern FD_xmpl *fdui;
extern FD_xmpl *fd_main_form;

FL_APPEVENT_CB optimize_idle_cb;

struct timeval timeout;
time_t idletimer; /* idle time for user */


int test_for_open_forms(int *some_form_open_flag)
{

*some_form_open_flag = 0;
//if(project_form_shown_flag) 
//	{
//	fl_show_alert("Close project form first (use ACCEPT)", "", "", 1);
//	*some_form_open_flag = 1;
//	}

return 1;
}/* end function test_for_open_forms */


void main_form_device_select_button_cb(FL_OBJECT *ob, long data)
{
int file;

if(playing_flag)
	{
	fl_show_alert(\
	"playing in progress",\
	"please use STOP button first",\
	"command cancelled.", 0);

	return;
	}

selected_audio_device++;
if(selected_audio_device > AUDIO_DEVICE_2) selected_audio_device = 0;

set_audio_device(selected_audio_device);

file = open(selected_audio_device_name,  O_RDWR | O_NONBLOCK);
if(file == -1)
	{
	audio_device_busy_flag = 1;
	}
else
	{
	close(file);
	audio_device_busy_flag = 0;
	}

save_general_settings();
} /* end function main_form_device_select_button_cb */


void main_form_repeat_mode_button_cb(FL_OBJECT *ob, long data)
{
repeat_mode++;
if(repeat_mode > PLAY_REPEAT_SELECTION) repeat_mode = 0;

set_repeat_mode_button(repeat_mode);
set_repeat_mode_menu(repeat_mode);

save_general_settings();
} /* end function main_form_repeat_mode_button_cb */


void main_form_stop_button_cb(FL_OBJECT *ob, long data)
{
int file;

play_stop();

file = open(selected_audio_device_name,  O_RDWR | O_NONBLOCK);
if(file == -1)
	{
	audio_device_busy_flag = 1;
	}
else
	{
	close(file);
	audio_device_busy_flag = 0;
	}

} /* end function void main_form_stop_button_cb */


void main_form_play_list_browser_cb(FL_OBJECT *ob, long data)
{
char *ptr;
int status;
int selected_line;
int mouse_button;
int selected;

if(debug_flag)
	{
	fprintf(stdout, "main_form_play_list_browser_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = abs( fl_get_browser(ob) );
if(! selected_line) return;

/* maintain visible indication that line is selected with single click */
fl_select_browser_line(ob, selected_line);

if(mouse_button == FL_LEFT_MOUSE)
	{
	selected_play_list = selected_line;

	ptr = line_to_play_list_name(selected_play_list);
	if(ptr)
		{
		if(selected_play_list_file_name) free(selected_play_list_file_name);
		selected_play_list_file_name = strsave(ptr);
		if(! selected_play_list_file_name) return;
		}

	save_play_lists();

	/* save o.a. selected_start_title */
	save_general_settings();

	load_titles();

	show_titles(SHOW_TOP);

	/* get the selected entry from the play_list */
	if(get_selected_entry(selected_play_list, &selected) )
		{
		fl_select_browser_line(fdui -> main_form_title_list_browser,\
		selected);	

		fl_set_browser_topline(fdui -> main_form_title_list_browser,\
		selected - 10);
		}

	/* show browser */
	select_title_list();

	fl_select_browser_line(ob, selected_play_list);

	/* save clicked position */
	save_general_settings();

	return;
	}

if(mouse_button == FL_MIDDLE_MOUSE)
	{
	}
if(mouse_button == FL_RIGHT_MOUSE)
	{
	}

}/* end function main_form_play_list_browser_cb */


void main_form_play_list_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;

if(debug_flag)
	{
	fprintf(stdout, "main_form_play_list_browser_double_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

/* form was modified */
main_form_modified_flag = 1;

}/* end function main_form_browser_play_list_double_cb */


void main_form_title_list_browser_cb(FL_OBJECT *ob, long data)
{
char *ptr;
int status;
int selected_line;
int mouse_button;

if(debug_flag)
	{
	fprintf(stdout, "main_form_title_list_browser_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = abs( fl_get_browser(ob) );
if(! selected_line) return;

/* maintain visible indication that line is selected with single click */
fl_select_browser_line(ob, selected_line);

if(mouse_button == FL_LEFT_MOUSE)
	{
	play_stop();

	selected_title = selected_line;

	ptr = line_to_filename(selected_title);
	if(! ptr) return;

	if(selected_file) free(selected_file);
	selected_file = strsave(ptr);

	/* mark selected in play_list */
	set_selected_entry_in_play_list(selected_title);

	save_play_lists();

	play_start();	
	} /* end if left mouse */
if(mouse_button == FL_MIDDLE_MOUSE)
	{
	toggle_play_flag(selected_line);
	}
if(mouse_button == FL_RIGHT_MOUSE)
	{
	swap_titles(selected_line);
	}

/* save o.a. selected_start_title */
save_general_settings();
save_titles();

show_titles(SHOW_SAME_POSITION);

fl_select_browser_line(ob, selected_line);

}/* end function main_form_title_list_browser_cb */


void main_form_title_list_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;

if(debug_flag)
	{
	fprintf(stdout, "main_form_title_list_browser_double_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

/* form was modified */
main_form_modified_flag = 1;

}/* end function main_form_title_list_browser_double_cb */


void main_form_search_input_field_cb(FL_OBJECT *ob, long data)
{
main_form_reset_last_found_line();

save_general_settings();
}/* end function main_form_search_input_field_cb */


void main_form_search_button_cb(FL_OBJECT *ob, long data)
{
switch(visible_browser)
	{
	case PLAY_LIST_BROWSER:
		search_and_select_next_play_list();
		break;
	case TITLE_LIST_BROWSER:
		search_and_select_next_title();
		break;
	} /* end switch visible_browser */

}/* end function main_form_search_button_cb */


void main_form_play_list_button_cb(FL_OBJECT *ob, long data)
{
select_play_list();

}/* end function main_form_play_list_button_cb */


void main_form_title_list_button_cb(FL_OBJECT *ob, long data)
{
select_title_list();

}/* end function main_form_title_list_button_cb */


void main_form_search_case_button_cb(FL_OBJECT *ob, long data)
{
main_form_reset_last_found_line();
}/* end function main_form_search_case_button_cb */


void main_form_volume_slider_cb(FL_OBJECT *ob, long data)
{
selected_volume = fl_get_slider_value(ob);

set_mixer_volume(selected_volume);

save_general_settings();
}/* end function main_form_volume_slider_cb */


void main_form_delete_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
int start_title;
int end_title;

/* mouse on NO */
if(! fl_show_question(
"This will delete the selected entry\nARE YOU VERY SURE?", 0) )
	{
	return;
	}

total_lines = fl_get_browser_maxline(fdui -> main_form_title_list_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(fdui -> main_form_title_list_browser,\
	s_line) )
		{
		main_form_modified_flag = 1;

		/* finally delete structure entry */
		delete_title(s_line);

		/* write modified structure list to disk */
		save_titles();
		}/* end selected line */
	}/* end for all lines */

show_titles(SHOW_SAME_POSITION);
}/* end function main_form_delete_button_cb */


void main_form_file_menu_cb(FL_OBJECT *ob, long data)
{
int some_form_open_flag;
char *ptr;
char temp[4096];
int selected;

selected = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(selected <= 0) return;

if(selected == AUTO_PLAY_ON_START)
	{
	auto_play_flag = 1 - auto_play_flag;
	set_auto_play_menu(auto_play_flag);

	save_general_settings();

	return;
	}
else if(selected == HELPERS)
	{
	show_helpers_form();

	return;
	}
else if(selected == EXIT) 
	{
	/* test if any forms are open */
	if(! test_for_open_forms(&some_form_open_flag) ) return;
	if(some_form_open_flag) return;

	exit(0);
	}

} /* end function main_form_file_menu_cb */


void main_form_play_list_menu_cb(FL_OBJECT *ob, long data)
{
int some_form_open_flag;
char *ptr;
char temp[4096];
int selected;
int s_line;
int total_lines;
FILE *fptr;

selected = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(selected <= 0) return;

if(selected == ADD_PLAY_LIST) 
	{
	if(visible_browser != PLAY_LIST_BROWSER)
		{
		fl_show_alert("Select Play list first", "", "", 0);

		return;
		}
		
	/* start  browser */
	sprintf(temp, "%s/.xmpl", home_dir);

	ptr = (char *)fl_show_fselector("SELECT A FILE", temp, "*.dat", "*.dat");
	if(! ptr) return;

	/* prevent empty entries */
	if(ptr[0] == 0) return;

	/* prevent ovewriting the database */
	sprintf(temp, "%s/.xmpl/xmpl.dat", home_dir);
	if(strcmp(ptr, temp) == 0)
		{
		fl_show_alert(\
		"This filename is reserved for the xmpl database",\
		"command cancelled", "", 0);

		return;
		}

	/* try to create the empty file so no error message later */
	fptr = fopen(ptr, "w");
	if(! fptr)
		{
		fl_show_alert("Could not create file", ptr, "command cancelled", 0);

		return;
		}
	fclose(fptr);

	/* add the entry to the browser */
	if(! add_play_list_in_position(ptr) ) return;

	show_play_lists(SHOW_SAME_POSITION);

//	fl_select_browser_line(fdui -> main_form_play__list_browser,\
//	s_line - 10);

	save_play_lists();

	save_general_settings();

	main_form_modified_flag = 1;

	return;
	}
else if(selected == DELETE_PLAY_LIST) 
	{
	if(visible_browser != PLAY_LIST_BROWSER)
		{
		fl_show_alert("Select Play list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will delete the selected play list\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

	total_lines = fl_get_browser_maxline(fdui -> main_form_play_list_browser);
	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_play_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			/* finally delete structure entry */
			delete_play_list(s_line);

			/* write modified structure list to disk */
			save_play_lists();

			show_play_lists(SHOW_SAME_POSITION);

			return;			
			}/* end selected line */
		}/* end for all lines */

	return;
	} /* end if delete */
else if(selected == RENAME_PLAY_LIST) 
	{
	if(visible_browser != PLAY_LIST_BROWSER)
		{
		fl_show_alert("Select Play list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will rename the selected play list\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

	total_lines =\
	fl_get_browser_maxline(fdui -> main_form_play_list_browser);

	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_play_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			/* finally delete structure entry */
			rename_play_list(s_line);

			/* write modified structure list to disk */
			save_play_lists();

			show_play_lists(SHOW_SAME_POSITION);

			return;			
			}/* end selected line */
		}/* end for all lines */

	return;
	} /* end if delete */

return;
} /* end function main_form_play_list_menu_cb */


void main_form_title_list_menu_cb(FL_OBJECT *ob, long data)
{
int a, c;
char *ptr, *ptr1;
char temp[4096];
int some_form_open_flag;
int selected;
int total_lines;
int s_line;
unsigned long frame;
unsigned long length;
int repeats;
int volume;

selected = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(selected <= 0) return;

if(selected == SINGLE_PLAY)
	{
	repeat_mode = PLAY_REPEAT_NONE;
	set_repeat_mode_button(repeat_mode);
	set_repeat_mode_menu(repeat_mode);

	save_general_settings();

	return;
	}
else if(selected == REPEAT_CURRENT)
	{
	repeat_mode = PLAY_REPEAT_CURRENT;
	set_repeat_mode_button(repeat_mode);
	set_repeat_mode_menu(repeat_mode);

	save_general_settings();

	return;
	}
else if(selected == REPEAT_SELECTION)
	{
	repeat_mode = PLAY_REPEAT_SELECTION;
	set_repeat_mode_button(repeat_mode);
	set_repeat_mode_menu(repeat_mode);

	save_general_settings();

	return;
	}
else if(selected == ADD_TITLE) 
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	/* start file browser */
	if(strlen(sound_dir) != 0) sprintf(temp, "%s/", sound_dir);
	else sprintf(temp, "%s/", home_dir);

	ptr = (char *)fl_show_fselector("SELECT A FILE", temp, "*.mp3", "*.mp3");
	if(! ptr) return;

	if(sound_dir) free(sound_dir);
	sound_dir = strsave(ptr);
	if(! sound_dir) return;

	ptr1 = strrchr(sound_dir, '/');
	if(ptr1)
		{
		*ptr1 = 0;
		}

	/* save sound_dir */
	save_general_settings();

	/* prevent empty entries */
	if(ptr[0] == 0) return;

	/* report double entries */
	report_flag = 1;

	/* add the entry to the browser */
	if(! add_title_in_position(ptr) ) return;

	report_flag = 0;

	show_titles(SHOW_SAME_POSITION);

	/* mark new entry in browser */
	title_to_line(ptr, &s_line);

	fl_select_browser_line(fdui -> main_form_title_list_browser,\
	s_line - 10);

	save_titles();

	main_form_modified_flag = 1;

	return;
	} /* end if end title */
else if(selected == DELETE_TITLE) 
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will delete the selected entry\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

	total_lines = fl_get_browser_maxline(fdui -> main_form_title_list_browser);
	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_title_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			/* finally delete structure entry */
			delete_title(s_line);

			/* write modified structure list to disk */
			save_titles();
			}/* end selected line */
		}/* end for all lines */

	show_titles(SHOW_SAME_POSITION);

	return;
	} /* end if delete title */
else if(selected == GET_SYSTEM_MP3s)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will append to your current list\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

//	delete_all_titles();

	get_all_files("mp3");

	show_titles(SHOW_TOP);

	save_titles();

	save_general_settings();

	return;
	} /* end if get system mp3s */
else if(selected == GET_SYSTEM_WAVs)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will append to your current list\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

//	delete_all_titles();

	get_all_files("wav");

	show_titles(SHOW_TOP);

	save_titles();

	save_general_settings();

	return;
	} /* end if get system wavs */
else if(selected == GET_SYSTEM_AVIs)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will append to your current list\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

//	delete_all_titles();

	get_all_files("avi");

	show_titles(SHOW_TOP);

	save_titles();

	save_general_settings();

	return;
	} /* end if get system avis */
else if(selected == GET_SYSTEM_USER_SPECIFIED_EXTENTIONS)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	/* mouse on NO */
	if(! fl_show_question(
	"This will append to your current list\nARE YOU VERY SURE?", 0) )
		{
		return;
		}

	/* get new extention from user */
	ptr = (char *) fl_show_input("extention to look for (example mpg)?",\
	"mpg");
	if(! ptr) return;		
		
//	delete_all_titles();

	get_all_files(ptr);

	show_titles(SHOW_TOP);

	save_titles();

	save_general_settings();

	return;
	} /* end if get system mpgs */
else if(selected == SET_START_FRAME)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	total_lines =\
	fl_get_browser_maxline(fdui -> main_form_title_list_browser);
	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_title_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			if(! get_start_frame(s_line, &frame) ) return;

			sprintf(temp, "%lu", frame);

			/* get start frame from user */
			ptr = (char *) fl_show_input("Start frame?", temp);
			if(! ptr) return;		
			
			frame = atol(ptr);

			/* set new value start frame */
			if(! set_start_frame(s_line, frame) ) return;

			/* show modified display */
			show_titles(SHOW_SAME_POSITION);

			/* maintain visible indication that line is selected */
			fl_select_browser_line(fdui -> main_form_title_list_browser,\
			s_line);

			/* write modified structure list to disk */
			save_titles();

			save_general_settings();

			return;
			}/* end selected line */
		}/* end for all lines */

	return;
	} /* end if set start frame */
else if(selected == SET_LENGTH)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	total_lines =\
	fl_get_browser_maxline(fdui -> main_form_title_list_browser);
	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_title_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			if(! get_length(s_line, &length) ) return;

			sprintf(temp, "%lu", length);

			/* get length from user */
			ptr = (char *) fl_show_input("Length?", temp);
			if(! ptr) return;		
			
			length = atol(ptr);

			/* set new value length */
			if(! set_length(s_line, length) ) return;

			/* show modified display */
			show_titles(SHOW_SAME_POSITION);

			/* maintain visible indication that line is selected */
			fl_select_browser_line(fdui -> main_form_title_list_browser,\
			s_line);

			/* write modified structure list to disk */
			save_titles();

			save_general_settings();

			return;
			}/* end selected line */
		}/* end for all lines */

	return;
	} /* end if set length */
else if(selected == SET_REPEATS)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	total_lines =\
	fl_get_browser_maxline(fdui -> main_form_title_list_browser);
	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_title_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			if(! get_repeats(s_line, &repeats) ) return;

			sprintf(temp, "%d", repeats);

			/* get repeats from user */
			ptr = (char *) fl_show_input("Repeats?", temp);
			if(! ptr) return;		
			
			repeats = atoi(ptr);

			/* set new value repeats */
			if(! set_repeats(s_line, repeats) ) return;

			/* show modified display */
			show_titles(SHOW_SAME_POSITION);

			/* maintain visible indication that line is selected */
			fl_select_browser_line(fdui -> main_form_title_list_browser,\
			s_line);

			/* write modified structure list to disk */
			save_titles();

			save_general_settings();

			return;
			}/* end selected line */
		}/* end for all lines */

	return;
	} /* end if set repeats */
else if(selected == SET_VOLUME)
	{
	if(visible_browser != TITLE_LIST_BROWSER)
		{
		fl_show_alert("Select Title list first", "", "", 0);

		return;
		}
		
	total_lines =\
	fl_get_browser_maxline(fdui -> main_form_title_list_browser);
	for(s_line = 1; s_line <= total_lines; s_line++)
		{
		if(fl_isselected_browser_line(fdui -> main_form_title_list_browser,\
		s_line) )
			{
			main_form_modified_flag = 1;

			if(! get_volume(s_line, &volume) ) return;

			sprintf(temp, "%d", volume);

			/* get volume from user */
			ptr = (char *) fl_show_input("Volume?", temp);
			if(! ptr) return;		
			
			volume = atoi(ptr);

			/* set new value volume */
			if(! set_volume(s_line, volume) ) return;

			/* show modified display */
			show_titles(SHOW_SAME_POSITION);

			/* maintain visible indication that line is selected */
			fl_select_browser_line(fdui -> main_form_title_list_browser,\
			s_line);

			/* write modified structure list to disk */
			save_titles();

			save_general_settings();

			return;
			}/* end selected line */
		}/* end for all lines */

	return;
	} /* end if set repeats */
else if(selected == ALLOW_DOUBLE_ENTRIES)
	{
	allow_double_title_entries = 1 - allow_double_title_entries;

	set_double_entry_menu(allow_double_title_entries);

	save_general_settings();
	return;
	} /* end if set repeats */

} /* end function main_form_title_list_menu_cb */


void main_form_alarm_menu_cb(FL_OBJECT *ob, long data)
{
int a, c;
char *ptr, *ptr1;
char temp[4096];
int some_form_open_flag;
int selected;
int total_lines;
int s_line;

selected = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(selected <= 0) return;

if(selected == SET_ALARM_TIME)
	{
	set_alarm(SET_ALARM_TIME);

	save_general_settings();

	return;
	}
else if(selected == SLEEP)
	{
	set_alarm(SLEEP);

	save_general_settings();

	return;
	}
else if(selected == ALARM)
	{
	set_alarm(ALARM);

	save_general_settings();

	return;
	} /* end if alarm */
else if(selected == POWER_DOWN_PC_ON_SLEEP)
	{
	set_alarm(POWER_DOWN_PC_ON_SLEEP);

	return;
	} /* end if power down */
} /* end function main_form_alarm_menu_cb */


void main_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
fontsizes_modified_flag = 1;
if(main_form_fontsize < 5) main_form_fontsize++;

set_font_sizes(main_form_fontsize);

save_fontsizes();
}/* end function main_form_fontsize_up_button_cb */


void main_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
fontsizes_modified_flag = 1;
if(main_form_fontsize > 0) main_form_fontsize--;

set_font_sizes(main_form_fontsize);

save_fontsizes();
}/* end function main_form_fontsize_down_button_cb */


void main_form_exit_switch_cb(FL_OBJECT *ob, long data)
{
int some_form_open_flag;

/* test if any forms are open */
if(! test_for_open_forms(&some_form_open_flag) ) return;
if(some_form_open_flag) return;

exit(1);
} /* end function main_form_exit_switch_cb */


int set_repeat_mode_button(int mode)
{
char text[80];
int color;

if(debug_flag)
	{
	printf("set_repeat_mode_button(): arg mode=%d\n", mode);
	}

switch(mode)
	{
	case PLAY_REPEAT_NONE:
		strcpy(text,"SINGLE\nPLAY");
		color = FL_COL1;
		break;
	case PLAY_REPEAT_CURRENT:
		strcpy(text,"REPEAT\nCURRENT");
		color = FL_BLUE;
		break;
	case PLAY_REPEAT_SELECTION:
		strcpy(text,"REPEAT\nSELECTION");
		color = FL_YELLOW;
		break;
	} /* end switch mode */

fl_set_object_color(fdui -> main_form_repeat_mode_button, color, color);
fl_set_object_label(fdui -> main_form_repeat_mode_button, text);

return 1;
} /* end function set_repeat_mode_button */


int select_play_list()
{
int selected;

if(debug_flag)
	{
	printf("select_play_list(): arg none\n");
	}

show_play_lists(SHOW_SAME_POSITION);

fl_select_browser_line(fdui -> main_form_play_list_browser,\
selected_play_list);

fl_hide_object(fdui -> main_form_title_list_browser);
fl_show_object(fdui -> main_form_play_list_browser);

visible_browser = PLAY_LIST_BROWSER;

return 1;
} /* end function select_play_list */


int select_title_list()
{
int selected;

if(debug_flag)
	{
	printf("select_title_list(): arg none\n");
	}

show_titles(SHOW_SAME_POSITION);

/* get the selected entry from the play_list */
if(get_selected_entry(selected_play_list, &selected) )
	{
	fl_select_browser_line(fdui -> main_form_title_list_browser,\
	selected);	

	fl_set_browser_topline(fdui -> main_form_title_list_browser,\
	selected - 10);
	}

fl_hide_object(fdui -> main_form_play_list_browser);
fl_show_object(fdui -> main_form_title_list_browser);

visible_browser = TITLE_LIST_BROWSER;

return 1;
} /* end function select_title_list */


