/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _XMPL_PROTO_H_
#define _XMPL_PROTO_H_

#include <setjmp.h>

extern int power_down_pc();
extern int set_power_down_menu(int flag);
extern int set_double_entry_menu(int flag);
extern int get_volume(int line, int *volume);
extern int set_volume(int line, int volume);
extern int title_to_start_length_repeats(\
	char *title, unsigned long *start, unsigned long *length, int *repeats);
extern int get_repeats(int line, int *repeats);
extern int set_repeats(int line, int repeats);
extern int get_start_frame(int line, unsigned long *frame);
extern int set_start_frame(int line, unsigned long frame);
extern int get_length(int line, unsigned long *length);
extern int set_length(int line, unsigned long length);
extern int show_helpers_form();
extern void helpers_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void helpers_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void helpers_form_input_cb(FL_OBJECT *ob, long data);
extern void helpers_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void helpers_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern char *get_helper_command(char *ptr);
extern int get_all_files(char *extention);
extern int set_mixer_volume(int volume);
extern int test_alarm();
extern int set_alarm_menu();
extern int set_alarm(int mode);
extern void main_form_alarm_menu_cb(FL_OBJECT *ob, long data);
extern int set_auto_play_menu(int auto_play_flag);
extern int rename_play_list(int line);
extern int set_font_sizes();
extern int stop_players();
extern int get_all_wavs();
extern int sort_play_lists();
extern int get_selected_entry(int line, int *selected);
extern int set_selected_entry_in_play_list(int line);
extern char *line_to_play_list_name(int line);
extern int select_title_list();
extern int select_play_list();
extern void main_form_device_select_button_cb(FL_OBJECT *ob, long data);
extern void *play_routine();
extern int play_init();
extern void play_start();
extern void play_stop();
extern struct title *lookup_title(char *name);
extern struct title *install_title_at_end_of_list(char *name);
extern int delete_title(int line);
int delete_all_titles();
int load_titles();
extern int save_titles();
extern int show_titles(int position);
extern char *line_to_filename(int line);
extern int title_to_line(char *text, int *line);
extern int title_to_next_line(int titlenr, int *line);
extern void replace(char *text, char *string, char *replace, char *result);
extern int search_and_select_next_title();
extern int main_form_reset_last_found_line();
extern int set_title_status(char *title, int status);
extern int get_title_status(char *title, int *status);
extern int search_in_for(char *database, char *data, int case_sensitive);
extern char *strstr_case_insensitive(char *s, char *t);
extern struct title *install_title_in_position(char *name);
extern int add_title_in_position(char *text);
extern int sort_titles();
extern int swap_title_position(struct title *ptop, struct title *pbottom);
extern int swap_titles(int line);
extern int toggle_play_flag(int line);
extern int get_play_status(int line, int *status, int *volume);
extern int idle_cb(XEvent *ev, void *data);
extern int set_title();
extern int save_setting(char *type, char *string);
extern char *load_setting(char *type);
extern int save_fontsizes();
extern int load_fontsizes();
extern int save_general_settings();
extern load_general_settings();
extern int set_tabs(int tabsize);
extern char *expand_tabs(char *text, int tabsize);
extern char *strsave(char *s);
int readline(FILE *file, char *contents);
extern int integer_to_fontsize(int fontsize);
extern int ogettime(
char *weekday,
char *month,
int *monthday,
int *hour,
int *minute,
int *second,
int *year
);
extern int set_title();
extern int main(int argc, char *argv[]);
extern int test_for_open_forms(int *some_form_open_flag);
extern void main_form_repeat_mode_button_cb(FL_OBJECT *ob, long data);
extern void main_form_play_button_cb(FL_OBJECT *ob, long data);
extern void main_form_play_list_button_cb(FL_OBJECT *ob, long data);
extern void main_form_title_list_button_cb(FL_OBJECT *ob, long data);
extern void main_form_stop_button_cb(FL_OBJECT *ob, long data);
extern void main_form_play_list_browser_cb(FL_OBJECT *ob, long data);
extern void main_form_title_list_browser_cb(FL_OBJECT *ob, long data);
extern void main_form_play_list_browser_double_cb(FL_OBJECT *ob, long data);
extern void main_form_title_list_browser_double_cb(FL_OBJECT *ob, long data);
extern void main_form_search_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_search_button_cb(FL_OBJECT *ob, long data);
extern void main_form_search_case_button_cb(FL_OBJECT *ob, long data);
extern void main_form_volume_slider_cb(FL_OBJECT *ob, long data);
extern void main_form_delete_button_cb(FL_OBJECT *ob, long data);
extern void main_form_add_button_cb(FL_OBJECT *ob, long data);
extern void main_form_file_menu_cb(FL_OBJECT *ob, long data);
extern void main_form_play_list_menu_cb(FL_OBJECT *ob, long data);
extern void main_form_title_list_menu_cb(FL_OBJECT *ob, long data);
extern void main_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void main_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void main_form_exit_switch_cb(FL_OBJECT *ob, long data);
extern int set_repeat_mode_button(int mode);

#endif /* _XMPL_PROTO_H_ */
